<#macro getQuickSearchPlaceholder view>
  <#assign isdrawcComma = false />
  <#if view?? && view.getPSAppDataEntity?? && view.getPSAppDataEntity()?? && view.getPSAppDataEntity().getAllPSAppDEFields?? && view.getPSAppDataEntity().getAllPSAppDEFields()??>
    <#list view.getPSAppDataEntity().getAllPSAppDEFields() as field>
      <#if field.isEnableQuickSearch()>
        <#if isdrawcComma>，<#else><#assign isdrawcComma = true /></#if><#t>
        ${field.getPSDEField().getLogicName()}<#t>
      </#if>
    </#list>
  </#if>
</#macro>
<#-- 按类型绘制 -->
<#macro renderByDetailType panelDetail view isMultiData>
    <#if panelDetail.getItemType()?? && panelDetail.getItemType() == "CONTAINER">
    <#-- 边缘布局 -->
    <#if panelDetail.getPSLayout().getLayout()?? && panelDetail.getPSLayout().getLayout() == "BORDER" >
    <app-scroll-container name="${panelDetail.getName()}"<#if isMultiData == true > :index="slotProps.data.index"</#if> :layoutModelDetails="layoutModelDetails">
    <#if panelDetail.getPSPanelItems()??>
        <#list panelDetail.getPSPanelItems() as panelItem>
        <template #${panelItem.getName()}>
        <@renderByDetailType panelItem view isMultiData />
        </template>
        </#list>
    </#if>
    </app-scroll-container>
    <#-- SIMPLEFLEX布局(栅格布局) -->
    <#elseif panelDetail.getPSLayout().getLayout()?? && panelDetail.getPSLayout().getLayout() == "SIMPLEFLEX" >
    <app-simpleflex-container name="${panelDetail.getName()}"<#if isMultiData == true > :index="slotProps.data.index"</#if> :layoutModelDetails="layoutModelDetails">
     <#if panelDetail.getPSPanelItems()??>
        <#list panelDetail.getPSPanelItems() as panelItem>
        <template #${panelItem.getName()}>
        <@renderByDetailType panelItem view isMultiData />
        </template>
        </#list>
    </#if>
    </app-simpleflex-container>
    <#else>
    <#assign isTempMultiData = isMultiData />
    <#assign iscurMultiData = false />
    <#if panelDetail.getDataRegionType?? && panelDetail.getDataRegionType()?? && panelDetail.getDataRegionType()=="MULTIDATA">
    <#assign isTempMultiData = true />
     <#assign iscurMultiData = true />
    </#if>
    <app-standard-container name="${panelDetail.getName()}"<#if (isTempMultiData == true) && (iscurMultiData == false) > :index="slotProps.data.index"</#if> :isMultiContainer="${iscurMultiData?c}" :layoutModelDetails="layoutModelDetails">
     <#if panelDetail.getPSPanelItems()??>
        <#list panelDetail.getPSPanelItems() as panelItem>
        <template <#if iscurMultiData == true>v-slot:${panelItem.getName()}="slotProps"<#else>#${panelItem.getName()}</#if>>
        <@renderByDetailType panelItem view isTempMultiData/>
        </template>
        </#list>
    </#if>
    </app-standard-container>
    </#if>
    <#elseif panelDetail.getItemType()?? && panelDetail.getItemType() == "TABPAGE">
    <app-tab-page name="${panelDetail.getName()}" :layoutModelDetails="layoutModelDetails">
        <#if panelDetail.getPSPanelItems?? && panelDetail.getPSPanelItems()??>
            <#list panelDetail.getPSPanelItems() as panelItem>
        <template #${panelItem.getName()}>
            <@renderByDetailType panelItem view isMultiData />
        </template>
            </#list>
        </#if>
    </app-tab-page>
    <#elseif panelDetail.getItemType()?? && panelDetail.getItemType() == "TABPANEL">
    <app-tab-panel name="${panelDetail.getName()}" :layoutModelDetails="layoutModelDetails">
        <#if panelDetail.getPSPanelTabPages?? && panelDetail.getPSPanelTabPages()??>
            <#list panelDetail.getPSPanelTabPages() as tabPage>
        <template #${tabPage.getName()}>
            <@renderByDetailType tabPage view isMultiData/>
        </template>
            </#list>
        </#if>
    </app-tab-panel>
    <#elseif panelDetail.getItemType()?? && panelDetail.getItemType() == "FIELD">
        <#if panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "AUTH_USERID">
        <@compress  single_line=true><app-login-input 
            class="app-login-user"  
            name="${panelDetail.getName()}" 
            <#if isMultiData == true >:index="slotProps.data.index"</#if>
            :layoutModelDetails="layoutModelDetails"
            :value="layoutData.${panelDetail.getName()}"
            defaultIcon="ios-contact" 
            @valueChange="handleValueChange" /></@compress>
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "AUTH_PASSWORD">
        <@compress  single_line=true><app-login-input
            class="app-login-password" 
            name="${panelDetail.getName()}"
            <#if isMultiData == true >:index="slotProps.data.index"</#if>
            defaultType="password"
            :layoutModelDetails="layoutModelDetails"
            :value="layoutData.${panelDetail.getName()}"
            defaultIcon="ios-key"
            @valueChange="handleValueChange" /></@compress>
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "AUTH_ORGPICK">
        <app-login-org name="${panelDetail.getName()}"<#if isMultiData == true > :index="slotProps.data.index"</#if> :layoutModelDetails="layoutModelDetails" :value="layoutData.${panelDetail.getName()}" @valueChange="handleValueChange" />
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "AUTH_VERIFICATIONCODE">
        <app-login-note-verify name="${panelDetail.getName()}"<#if isMultiData == true > :index="slotProps.data.index"</#if> :layoutModelDetails="layoutModelDetails" :value="layoutData.${panelDetail.getName()}" @valueChange="handleValueChange" />
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "AUTH_LOGINMSG">
        <app-login-message name="${panelDetail.getName()}"<#if isMultiData == true > :index="slotProps.data.index"</#if> :layoutModelDetails="layoutModelDetails" :value="layoutData.${panelDetail.getName()}" />
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "APP_APPTITLE">
        <app-preset-title name="${panelDetail.getName()}"<#if isMultiData == true > :index="slotProps.data.index"</#if> :layoutModelDetails="layoutModelDetails"/>
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "VIEW_PAGECAPTION">
        <app-preset-caption name="${panelDetail.getName()}"<#if isMultiData == true > :index="slotProps.data.index"</#if> :layoutModelDetails="layoutModelDetails">${view.caption}</app-preset-caption>
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "FIELD_TEXT_DYNAMIC">
        <app-preset-text name="${panelDetail.getName()}"<#if isMultiData == true > :index="slotProps.data.index"</#if> :value="layoutData.${panelDetail.getViewFieldName()}" :layoutModelDetails="layoutModelDetails"/>
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "FIELD_SWITCH">
        <app-preset-switch name="${panelDetail.getName()}" <#if isMultiData == true > :index="slotProps.data.index"</#if> :layoutModelDetails="layoutModelDetails" :value="layoutData.${panelDetail.getName()}" @valueChange="handleValueChange"/>
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "FIELD_QRCODE">
        <app-preset-qrcode name="${panelDetail.getName()}"<#if isMultiData == true > :index="slotProps.data.index"</#if> :layoutModelDetails="layoutModelDetails" :value="layoutData.${panelDetail.getName()}" />
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "FIELD_TEXTBOX">
        <app-preset-text-input name="${panelDetail.getName()}"<#if isMultiData == true > :index="slotProps.data.index"</#if> :layoutModelDetails="layoutModelDetails" :value="layoutData.${panelDetail.getName()}" @valueChange="handleValueChange"/>
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "AUTH_ORGPICK">
            <app-index-org-select name="${panelDetail.getName()}"<#if isMultiData == true > :index="slotProps.data.index"</#if> :layoutModelDetails="layoutModelDetails"></app-index-org-select>
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "FIELD_IMAGE">
            <app-field-image-dynamic name="${panelDetail.getName()}"<#if isMultiData == true > :index="slotProps.data.index"</#if> :value="layoutData['${panelDetail.getName()}']" :layoutModelDetails="layoutModelDetails"></app-field-image-dynamic>
        <#elseif panelDetail.getPSEditor?? && panelDetail.getPSEditor()?? && panelDetail.getPSEditor().getPredefinedType?? && panelDetail.getPSEditor().getPredefinedType()?? && panelDetail.getPSEditor().getPredefinedType() == "FIELD_CAROUSEL">
            <app-rawitem-carousel name="${panelDetail.getName()}"<#if isMultiData == true > :index="slotProps.data.index"</#if> type="FIELD_CAROUSEL" :data="layoutData" :layoutModelDetails="layoutModelDetails"></app-rawitem-carousel>
        <#else>
        <span>属性项</span>
        </#if>
    <#elseif panelDetail.getItemType()?? && panelDetail.getItemType() == "RAWITEM">
        <#if panelDetail.getPSRawItem?? && panelDetail.getPSRawItem()??>
        <#assign rawdetail = panelDetail.getPSRawItem()/>
        <#if  rawdetail.getPredefinedType?? && rawdetail.getPredefinedType()?? && rawdetail.getPredefinedType() == "STATIC_IMAGE">
        <app-rawitem-image
            name="${panelDetail.getName()}"
            <#if isMultiData == true >:index="slotProps.data.index"</#if>
            <#if rawdetail.getPSSysImage?? && rawdetail.getPSSysImage()?? && rawdetail.getPSSysImage().getImagePath?? && rawdetail.getPSSysImage().getImagePath()??>
            imgUrl="${ rawdetail.getPSSysImage().getImagePath() }"
            </#if>
            <#if rawdetail.getPSSysImage?? && rawdetail.getPSSysImage()?? && rawdetail.getPSSysImage().getCssClass?? && rawdetail.getPSSysImage().getCssClass()??>
            imageClass="${ rawdetail.getPSSysImage().getCssClass() }"
            </#if>
            :layoutModelDetails="layoutModelDetails"
            >
            </app-rawitem-image>
        <#elseif rawdetail.getPredefinedType?? && rawdetail.getPredefinedType()?? && rawdetail.getPredefinedType() == "STATIC_CAROUSEL">
        <app-rawitem-carousel
            name="${panelDetail.getName()}"
            type="STATIC_CAROUSEL"
            <#if isMultiData == true >:index="slotProps.data.index"</#if>
            :value=<@compress  single_line=true>"[
            <#if rawdetail.getPSRawItemParams?? && rawdetail.getPSRawItemParams()??>
            <#list rawdetail.getPSRawItemParams() as param>{                
                 <#if param.key??>
                    key:'${param.key}',
                </#if>
                 <#if param.value??>
                    value:'${param.value}',
                <#elseif param.getPSSysImage?? && param.getPSSysImage()?? && param.getPSSysImage().getImagePath?? && param.getPSSysImage().getImagePath()?? && param.getPSSysImage().getImagePath?? && param.getPSSysImage().getImagePath() != "">
                    imgPath:'${param.getPSSysImage().getImagePath()}',
                    type:'img'
                 <#elseif param.getPSSysImage?? && param.getPSSysImage()?? && param.getPSSysImage().getCssClass?? && param.getPSSysImage().getCssClass()??>
                    iconClass:'${param.getPSSysImage().getCssClass()}',
                    type:'icon'
                </#if> 
                }<#if param_has_next>,</#if>              
            </#list>
            </#if>
            ]"</@compress>
            :layoutModelDetails="layoutModelDetails"
            :data="layoutData"
        >
        </app-rawitem-carousel>
        <#elseif rawdetail.getPredefinedType?? && rawdetail.getPredefinedType()?? && rawdetail.getPredefinedType() == "STATIC_VIDEOPLAYER">
        <app-rawitem-video 
        name="${panelDetail.getName()}"
        <#if isMultiData == true >:index="slotProps.data.index"</#if>
        :layoutModelDetails="layoutModelDetails"
        :videoParmas=<@compress  single_line=true>"[
            <#if rawdetail.getPSRawItemParams?? && rawdetail.getPSRawItemParams()??>
            <#list rawdetail.getPSRawItemParams() as param>{                
                 <#if param.key??>
                    key:'${param.key}',
                </#if>
                 <#if param.value??>
                    value:'${param.value}',
                </#if> 
                }<#if param_has_next>,</#if>              
            </#list>
            </#if>
            ]"</@compress>        
        />
        <#elseif panelDetail.getPSRawItem?? && panelDetail.getPSRawItem()?? && panelDetail.getPSRawItem().getPredefinedType?? && panelDetail.getPSRawItem().getPredefinedType()?? && panelDetail.getPSRawItem().getPredefinedType() == 'NAV_POS'>
            <app-nav-pos name="${panelDetail.getName()}"<#if isMultiData == true > :index="slotProps.data.index"</#if> :layoutModelDetails="layoutModelDetails" :navData="layoutModelDetails['${panelDetail.getName()}'].navData"></app-nav-pos>
        <#elseif panelDetail.getPSRawItem?? && panelDetail.getPSRawItem()?? && panelDetail.getPSRawItem().getPredefinedType?? && panelDetail.getPSRawItem().getPredefinedType()?? && panelDetail.getPSRawItem().getPredefinedType() == 'NAV_BREADCRUMB'>
            <app-index-nav-breadcrumb name="${panelDetail.getName()}"<#if isMultiData == true > :index="slotProps.data.index"</#if> :layoutModelDetails="layoutModelDetails"<#if view?? && view.getViewType?? && view.getViewType() == 'APPINDEXVIEW'> indexViewTag="${srffilepath2(view.getCodeName())}"</#if>></app-index-nav-breadcrumb>
        <#elseif panelDetail.getPSRawItem?? && panelDetail.getPSRawItem()?? && panelDetail.getPSRawItem().getPredefinedType?? && panelDetail.getPSRawItem().getPredefinedType()?? && (panelDetail.getPSRawItem().getPredefinedType() == 'STATIC_LABEL' || panelDetail.getPSRawItem().getPredefinedType() == 'STATIC_TEXT')>
        <app-preset-text name="${panelDetail.getName()}"<#if isMultiData == true > :index="slotProps.data.index"</#if> :layoutModelDetails="layoutModelDetails"/>
        <#elseif panelDetail.getPSRawItem?? && panelDetail.getPSRawItem()?? && panelDetail.getPSRawItem().getPredefinedType?? && panelDetail.getPSRawItem().getPredefinedType()?? && panelDetail.getPSRawItem().getPredefinedType() == 'NAV_TABS'>
            <app-index-nav-tabs name="${panelDetail.getName()}"<#if isMultiData == true > :index="slotProps.data.index"</#if> :layoutModelDetails="layoutModelDetails"></app-index-nav-tabs>
        <#elseif panelDetail.getPSRawItem?? && panelDetail.getPSRawItem()?? && panelDetail.getPSRawItem().getPredefinedType?? && panelDetail.getPSRawItem().getPredefinedType()?? && panelDetail.getPSRawItem().getPredefinedType() == 'AUTH_USERINFO'>
            <app-index-user-info name="${panelDetail.getName()}"<#if isMultiData == true > :index="slotProps.data.index"</#if> :layoutModelDetails="layoutModelDetails"></app-index-user-info>
        </#if>
     </#if>
    <#elseif panelDetail.getItemType()?? && panelDetail.getItemType() == "BUTTON">
        <#if panelDetail.getPSUIAction?? && panelDetail.getPSUIAction()?? && panelDetail.getPSUIAction().getPredefinedType?? && panelDetail.getPSUIAction().getPredefinedType()?? && panelDetail.getPSUIAction().getPredefinedType() == "APP_LOGIN">
        <app-login-button class="app-login-button" name="${panelDetail.getName()}"<#if isMultiData == true > :index="slotProps.data.index"</#if>  :layoutModelDetails="layoutModelDetails" defaultStyle='primary' @itemClick="handleButtonClick" />
        <#elseif panelDetail.getPSUIAction?? && panelDetail.getPSUIAction()?? && panelDetail.getPSUIAction().getPredefinedType?? && panelDetail.getPSUIAction().getPredefinedType()?? && panelDetail.getPSUIAction().getPredefinedType() == "DATA_CANCELCHANGES">
        <app-login-button class="app-reset-button" name="${panelDetail.getName()}"<#if isMultiData == true > :index="slotProps.data.index"</#if>  :layoutModelDetails="layoutModelDetails" defaultStyle='success' @itemClick="handleButtonClick" />
        <#elseif panelDetail.getPSUIAction?? && panelDetail.getPSUIAction()?? && panelDetail.getPSUIAction().getPredefinedType?? && panelDetail.getPSUIAction().getPredefinedType()?? && panelDetail.getPSUIAction().getPredefinedType() == "APP_LOGOUT">
        <app-login-button class="app-logout-button" name="${panelDetail.getName()}"<#if isMultiData == true > :index="slotProps.data.index"</#if>  :layoutModelDetails="layoutModelDetails" @itemClick="handleButtonClick" />
        <#elseif panelDetail.getPSUIAction?? && panelDetail.getPSUIAction()??>
        <app-preset-button
            name="${panelDetail.getName()}" 
            <#if isMultiData == true > :index="slotProps.data.index"</#if>
            :layoutModelDetails="layoutModelDetails"
            <#if panelDetail.getCaptionItemName?? && panelDetail.getCaptionItemName() != ''>
            :caption="layoutData.${panelDetail.getCaptionItemName()}"
            :tooltip="layoutData.${panelDetail.getCaptionItemName()}"
            <#else>
            caption="${panelDetail.getPSUIAction().getCaption()}"
            tooltip="${panelDetail.getPSUIAction().getTooltip()}"
            </#if>
            @itemClick="handleButtonClick">
        </app-preset-button>
        <#else>
        <app-preset-button
            name="${panelDetail.getName()}" 
            <#if isMultiData == true > :index="slotProps.data.index"</#if>
            :layoutModelDetails="layoutModelDetails"
            caption="${panelDetail.getCaption()}"
            @itemClick="handleButtonClick">
        </app-preset-button>
        </#if>
    <#elseif panelDetail.getItemType()?? && panelDetail.getItemType() == "CTRLPOS">
            <app-ctrl-pos name="${panelDetail.getName()}" <#if isMultiData == true > :index="slotProps.data.index"</#if> :layoutModelDetails="layoutModelDetails">
        <#if panelDetail.getName() == 'quicksearchbar' || panelDetail.getName() == 'QUICKSEARCHBAR'>
                <i-input v-model="query" search enter-button @on-search="onSearch($event)" class='quick-search-input' style='max-width: 400px;' placeholder="<@getQuickSearchPlaceholder view />" />
        <#elseif view?? && view.hasPSControl?? && view.hasPSControl(panelDetail.getName())>
                ${P.getCtrlCode(panelDetail.getName(), 'CONTROL.html').code}
        <#else>
                <span>部件占位${panelDetail.getName()}</span>
        </#if>
            </app-ctrl-pos>
    <#elseif panelDetail.getItemType()?? && panelDetail.getItemType() == "USERCONTROL">
        <#if panelDetail.getPredefinedType?? && panelDetail.getPredefinedType()?? && panelDetail.getPredefinedType() == "AUTH_CAPTCHA">
        <app-login-captcha name="${panelDetail.getName()}"<#if isMultiData == true > :index="slotProps.data.index"</#if> :layoutModelDetails="layoutModelDetails" :value="layoutData.${panelDetail.getName()}" @valueChange="handleValueChange" />
        <#elseif panelDetail.getPredefinedType?? && panelDetail.getPredefinedType()?? && panelDetail.getPredefinedType() == "AUTH_SSO">
        <app-login-third name="${panelDetail.getName()}"<#if isMultiData == true > :index="slotProps.data.index"</#if> :layoutModelDetails="layoutModelDetails" :value="layoutData.${panelDetail.getName()}" />
        <#else>
        <span>用户自定义控件</span>
        </#if>
    <#else>
    <span>${panelDetail.getItemType()}暂未支持</span>
    </#if>
</#macro>